<?php
require_once 'lib/list_util.php';

require_once 'ExUa_vod_category.php';
require_once 'ExUa_movie.php';
require_once 'ExUa_movie_series.php';

class ExUaApi
{
    ////////////////////////////////////////////////////////////////////////////////////
    //
    //              VIDEO/AUDIO List
    //
    private static function get_series($video_id, $page, $playlist_url, &$series, &$is_has_new, &$plugin_cookies)
    {
        // get urls
        try
        {
            $doc = HD::http_get_document($playlist_url);
        }
        catch(Exception $e)
        {
            hd_print("Connection error!!!");
            return false;
        }

        $series_url = explode(chr(10), $doc);

        $get_titles = false;

        // get titles for those urls
        $doc = $page;
        if ($doc)
            $get_titles = true;

        $n = 0;
        $links_exist = false;
        foreach($series_url as $s)
        {
            $is_audio = false;
            
            if (strlen($s) === 0)
                continue;

            $title = "Серия " . ($n + 1);
            if ($get_titles)
            {
                $tmp = explode("www.ex.ua", $s);
                // search for '/get/xxxxx'
                $tmp = explode($tmp[1], $doc);
                if (count($tmp) > 1)
                {
                    $links_exist = true;
                    if (!$is_has_new)
                    {
                        if (isset($plugin_cookies->$video_id))
                        {
                            if (!ListUtil::is_in_list($plugin_cookies->$video_id, $s))
                                $is_has_new = true;
                        }
                    }
                    $tmp = explode("title='", $tmp[1]);
                    $tmp = explode("'", $tmp[1]);
                    $title = $tmp[0];
                    if
                    (
                        strstr($title, '.mp3') ||
                        strstr($title, '.flac') ||
                        strstr($title, '.ape') ||
                        strstr($title, '.wav') ||
                        strstr($title, '.wv')
                    )
                    {
                        $is_audio = true;
                    }
                    else if (preg_match("/s\d\de\d\d/i", $title, $regs))
                    {
                        $r = $regs[0];
                        $season = $r[1] === '0' ? $r[2] : $r[1] . $r[2];
                        $ep = $r[4] === '0' ? $r[5] : $r[4] . $r[5];
                        $title = "Сезон $season Эпизод $ep";
                    }
                }
                else
                {
                    // no valid links - skip
                    continue;
                }
            }

            $episode = new ExUaMovieSeries($n);
            $episode->name = self::clear($title);
            $episode->playback_url = $s;
	        $episode->playback_url_is_stream_url = true;
            $episode->is_audio = $is_audio;

            array_push
            (
                $series,
                $episode
            );
            ++$n;
        }

        return $links_exist;
    }

    private static function parse_video_page($video_id, &$items, $from_fav, $plugin_cookies, $page = '', $video_page_ref = '')
    {
        
        $api = "http://www.ex.ua";
        
        if ($video_id != -1)
        {
            $video_page_ref = sprintf(ExUaConfig::MOVIE_PAGE_URL_FORMAT, $video_id);
            
            // download category video page
            try
            {
                $page = HD::http_get_document($video_page_ref);
            }
            catch(Exception $e)
            {
                hd_print("Connection error!!!");
                return false;
            }
        }
        
        // get playlist
        $sub_view = false;
        $playlist_url = '';
        $tmp = explode("/playlist/", $page);        
        if (count($tmp) < 2)    // nothing to play
        {
            // try to find sub-pages
            if 
            (
                strpos($page, 'class=include_0') === false &&
                strpos($page, 'class=include_1') === false
            )
            {
                return false;
            }
            $sub_view = $video_page_ref . "?per=20&v=1,0";
        }
        else
        {
            $tmp = explode("'", $tmp[1]);
            $playlist_url = $api . "/playlist/" . $tmp[0];
        }

        // get image
        $video_image = "";
        $tmp = explode('<link rel="image_src" href="http://www.ex.ua', $page);
        if (count($tmp) > 1)
        {
            $tmp = explode('?', $tmp[1]);
            $video_image = $tmp[0];
//            hd_print("---> image mask $video_image");

            // get real picture url
            $tmp = explode($video_image, $page);
            $tmp = explode("<img src='", $tmp[1]);
            $video_image = $tmp[count($tmp) - 1] . $video_image;

            $thumb_quality = (isset($plugin_cookies->thumb_quality) ? $plugin_cookies->thumb_quality : 'yes');
            if ($thumb_quality === 'no')
            {
                $video_image .= '?100';
//                hd_print("--->>> Get small picture: $video_image");
            }
            else
            {
                $video_image .= '?800';
//                hd_print("--->>> Get big picture: $video_image");
            }
        }

        // get video title
        $video_title = "";
        $tmp = explode('<meta name="title" content="', $page);
        if (count($tmp) > 1)
        {
            $tmp = explode('"', $tmp[1]);
            $video_title = $tmp[0];
        }
        else
        {
            hd_print("--->>> NOTHING!!!");
            return false;
        }
        
        $is_has_new = false;
        // get series count
        $n_series = 0;
        $series = false;
        // download playlist
        if (strlen($playlist_url))
        {
            $series = array();
            $links_exist = ExUaApi::get_series($video_id, $page, $playlist_url, $series, $is_has_new, $plugin_cookies);
            // no valid links
            if ($links_exist === false)
                return false;
        }
        
        // get description block
        $descr_block = '';
        $tmp = explode("<a href='/user/", $page);
        if (count($tmp) > 1)
        {
             $descr_block = $tmp[1];
        }
        
        if (strlen($descr_block) > 0)
        {
            $descr_block = preg_replace("/(<b>|<\/b>|<font color='\S\S\S\S\S\S\S'>|<\/font>|<i>|<\/i>|<u>|<\/u>)/i", "", $descr_block);
//            hd_print("--->>> Block: $descr_block");
            
            // get year
            $year = '';
            $tmp = preg_split("/Год[^:]*: /i", $descr_block);
            if (count($tmp) > 1)
            {
                $year = strstr($tmp[1], '<', true);
            }
            
            // genre
            $genre = '';
            if (preg_match("/Жанр:(.*)</i", $descr_block, $tmp))
            {
                $tmp = strchr($tmp[0], ":");
                $tmp = explode("<", $tmp);
                $genre = ltrim($tmp[0], " :");
            }
            
            // get country
            $country = '';
            if (preg_match("/(Страна|Выпущено|Країна):(.*)</i", $descr_block, $tmp))
            {
                $tmp = strchr($tmp[0], ":");
                $tmp = explode("<", $tmp);
                $country = ltrim($tmp[0], " :");
            }
            
            // director
            $director = '';
            if (preg_match("/(Режиссер|Режисер):(.*)</i", $descr_block, $tmp))
            {
                $tmp = strchr($tmp[0], ":");
                $tmp = explode("<", $tmp);
                $director = ltrim($tmp[0], " :");
            }

            // get actors
            $actors = '';
            if (preg_match("/(В ролях|Актори|В главных ролях):(.*)</i", $descr_block, $tmp))
            {
                $tmp = strchr($tmp[0], ":");
                $tmp = explode("<", $tmp);
                $actors = ltrim($tmp[0], " :");
            }

            // get duration
            $duration = '';
            $duration_min = '';
            if (preg_match("/Продолжительность:(.*)</i", $descr_block, $tmp))
            {
//                hd_print("--->>> $tmp[0]");
                $tmp = strchr($tmp[0], ":");
                $tmp = explode("<", $tmp);
                $duration = ltrim($tmp[0], " :");
                // XXX мин format
                if (preg_match("/(\d*)(.*)мин/i", $duration, $tmp))
                {
                    preg_match("/(\d*)/i", $tmp[0], $tmp);
                    $duration_min = $tmp[0];
                }
                // XX:XX:XX format
                else if (preg_match("/\d\d:\d\d:\d\d/i", $duration, $tmp))
                {
                    $tmp = $tmp[0];
                    $duration_min = ($tmp[0]*10+$tmp[1])*60+($tmp[3]*10+$tmp[4]);
                }
            }

            // get description
            $description = '';
            if 
            (
                preg_match("/<p>Сюжет(.*)</i", $descr_block, $tmp) ||
                preg_match("/<p>Сюжет:(.*)</i", $descr_block, $tmp)
            )
            {
                //hd_print("--->>> Descrition1: $tmp[0]");
                $tmp = preg_replace("/(<br>|<p>)/i", "", $tmp[0]);
                //hd_print("--->>> Descrition1.1: $tmp");
                $tmp = explode("<", $tmp);
                //hd_print("--->>> Descrition1.2: $tmp[0]");
                $description = str_ireplace("Сюжет", "", $tmp[0]);
            }
            else if (preg_match("/(писание|фильме|южет(.*)|содержание):(.*)</i", $descr_block, $tmp))
            {
                //hd_print("--->>> Descrition2: $tmp[0]");
                $tmp = strchr($tmp[0], ":");
                $tmp = preg_replace("/(<br>|<p>)/i", "", $tmp);
                $tmp = explode("<", $tmp);
                $description = ltrim($tmp[0], " :");
            }
        }
        
        // push video in to videos list
        $movie = new ExUaMovie(HD::str_remove_spec($video_id));

        $movie->has_new_series = $is_has_new;
        
        if ($sub_view)
        {
            $movie->set_sub_view($sub_view);
        }
        
        $movie->set_data
        (
            HD::str_remove_spec(self::clear($video_title)),
            '',                                 // name original
            HD::str_remove_spec(self::clear($description)),
            HD::str_remove_spec($video_image),
            $duration_min,
            HD::str_remove_spec(self::clear($year)),
            HD::str_remove_spec(self::clear($director)),
            '',                                 // $scenarios_str
            HD::str_remove_spec(self::clear($actors)),
            HD::str_remove_spec(self::clear($genre)),
            '',                                 // $rate_imdb,
            '',                                 // $rate_kinopoisk,
            '',                                 // $rate_mpaa,
            HD::str_remove_spec(self::clear($country)),
            ''                                  // $budget
        );

        if ($series)
        {
            foreach ($series as $s)
            {
                $movie->add_episode($s);
            }
        }
        array_push
        (
            $items,
            $movie
        );
        
        return true;
    }

    private static function parse_page($url, &$items, $from_fav, $plugin_cookies)
    {
        hd_print("--->>> parse_page: $url");

        $api = "http://www.ex.ua";

        // download category (sub_view) video page
        try
        {
            $doc = HD::http_get_document($url);
        }
        catch(Exception $e)
        {
            hd_print("Connection error!!!");
            return false;
        }
        
        if (is_null($doc))
            return false;

        // get list of videos
        $tmp = explode("class=include_1", $doc);
        if (count($tmp) < 2)
            $tmp = explode("class=panel", $doc);

        if (count($tmp) > 1)
        {
            $tmp = explode("</table>", $tmp[1]);
            $tmp = $tmp[0];
            $videos = explode("<tr><td><a href='/view/", $tmp);
            unset($videos[0]);
            $videos = array_values($videos);
        }
        else
        {
            return ExUaApi::parse_video_page(-1, $items, $from_fav, $plugin_cookies, $doc, $url);
        }
    

        // iterate through videos
        foreach($videos as $video)
        {
            // get video page ref
            $tmp = explode("'", $video);
            $video_page_ref = '/view/' . $tmp[0];

            // get video id
            $tmp = explode("/view/", $video_page_ref);
            $tmp = explode("?", $tmp[1]);
            $video_id = $tmp[0];
            ExUaApi::parse_video_page($video_id, $items, $from_fav, $plugin_cookies);

        }
        
    }

    public static function get_items($start_url, &$m_feed, $category_id, $from_fav, &$plugin_cookies)
    {
        if ($start_url)
        {
            $url = $start_url;
            // select page
            if ($m_feed > 0)
                $url .= "&p=" . $m_feed;
        }
        else
        {
            $url_mask = ExUaConfig::MOVIE_LIST_URL_FORMAT;
            
            // select page
            if ($m_feed > 0)
                $url_mask .= "&p=" . $m_feed;
                
            $url = sprintf($url_mask, $category_id);
        }

        ++$m_feed;
        
        $items = array();

        ExUaApi::parse_page($url, $items, $from_fav, $plugin_cookies);
        
        return $items;
    }

    ////////////////////////////////////////////////////////////////////////////////////
    //
    //              VIDEO/AUDIO Category List
    //

    private static function fill_categories($videos, &$category_index)
    {
        $category_list = array();
        
        // iterate through categories
        foreach($videos as $video)
        {
            // get category id
            $tmp = explode('?', $video);
            $category_id = $tmp[0];
            if ($category_id == '/ja/video' || $category_id == '/ja/audio')
                continue;
        
            // get category title
            $tmp = explode('<b>', $video);
            $tmp = explode('</b>', $tmp[1]);
            $category_name = $tmp[0];
        
            // get category view reference
            $tmp = explode("<a href='", $tmp[1]);
            $tmp = explode("' class=info>Статей: ", $tmp[1]);
            $category_ref = $tmp[0];
        
            // get category items count
            if (count($tmp) > 1)
            {
                $tmp = explode("</a>", $tmp[1]);
                $category_items_count = $tmp[0];
            }

            $cat =
                new ExUaVodCategory
                    (
                        $category_id,
                        $category_name,
                        $category_ref,
                        $category_items_count
                    );

            $category_list[] = $cat;

            $category_index[$cat->get_id()] = $cat;
        }
        
        return $category_list;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function get_categories($category_type, &$category_index)
    {
        $category_url = '';
        switch($category_type)
        {
        case 'vod_categories':
        case '/ru/video':
            $category_url = ExUaConfig::VOD_CATEGORIES_URL;
            $delimiter = ExUaConfig::VOD_CATEGORIES_DELIMITER;
            break;
        case 'audio_categories':
        case '/ru/audio':
            $category_url = ExUaConfig::AUDIO_CATEGORIES_URL;
            $delimiter = ExUaConfig::AUDIO_CATEGORIES_DELIMITER;
            break;
        case 'vod_languages':
            $category_url = ExUaConfig::VOD_LANGUAGES_URL;
            $delimiter = ExUaConfig::VOD_LANGUAGES_DELIMITER;
            break;
        case 'audio_languages':
            $category_url = ExUaConfig::AUDIO_LANGUAGES_URL;
            $delimiter = ExUaConfig::AUDIO_LANGUAGES_DELIMITER;
            break;
        default:
            $category_url = 'http://www.ex.ua' . $category_type;
            $delimiter = ExUaConfig::VOD_LANGUAGES_CATEGORY_DELIMITER;
            break;
        }
        try
        {
            $doc = HD::http_get_document($category_url);
        }
        catch(Exception $e)
        {
            hd_print("Connection error!!!");
            return false;
        }
     
        if (is_null($doc))
            return false;//throw new Exception('Can not fetch playlist');

        // get list of categories
        $videos = explode($delimiter, $doc);
        unset($videos[0]);
        $videos = array_values($videos);
        
        hd_print("--->>> $category_type categories count: " . count($videos));

        return ExUaApi::fill_categories($videos, $category_index);
    }

    ////////////////////////////////////////////////////////////////////////////////////
    //
    //              VIDEO/AUDIO Search
    //
    
    public static function search_get_items($search_text, &$m_feed, $category_id, $from_fav, &$plugin_cookies)
    {
        hd_print("--->>> search for: $search_text");

        $url = false;
        if ($category_id)
        {
            // select page
            if ($m_feed > 0)
            {
                $url_mask = ExUaConfig::SEARCH_CATEGORY_MOVIE_LIST_PAGE_URL_FORMAT;
                $url = sprintf($url_mask, $category_id, $search_text, $m_feed);
            }
            else
            {
                $url_mask = ExUaConfig::SEARCH_CATEGORY_MOVIE_LIST_URL_FORMAT;
                $url = sprintf($url_mask, $category_id, $search_text);
            }
        }
        else
        {
            // select page
            if ($m_feed > 0)
            {
                $url_mask = ExUaConfig::SEARCH_MOVIE_LIST_PAGE_URL_FORMAT;
                $url = sprintf($url_mask, $search_text, $m_feed);
            }
            else
            {
                $url_mask = ExUaConfig::SEARCH_MOVIE_LIST_URL_FORMAT;
                $url = sprintf($url_mask, $search_text);
            }
        }
        
        ++$m_feed;
        
        $items = array();

        ExUaApi::parse_page($url, $items, false, $plugin_cookies);
        
        return $items;
    }

    public static function get_search_category_id($category_ref, &$plugin_cookies)
    {
        $url = 'http://www.ex.ua' . $category_ref;
        try
        {
            $doc = HD::http_get_document($url);
        }
        catch(Exception $e)
        {
            hd_print("Connection error!!!");
            return ActionFactory::show_title_dialog('Для этой категории нет поиска');
        }
        
        $tmp = explode("<form name=search action='/search'>", $doc);
        if (count($tmp) < 2)
            return false;
            
        $tmp = explode("name=", $tmp[1]);
        if (count($tmp) < 2)
            return false;
            
        $var = strstr($tmp[1], " ", true);
        
        $tmp = explode("value='", $tmp[1]);
        if (count($tmp) < 2)
            return false;
            
        $value = strstr($tmp[1], "'", true);
        
        return "$var=$value";
    }
    ////////////////////////////////////////////////////////////////////////////////////
    //
    //              VIDEO/AUDIO get movie by id
    //
    
    public static function get_movie_by_id($id, &$plugin_cookies)
    {
        $movies = array();
        self::parse_video_page($id, $movies, false, $plugin_cookies);
        
        return count($movies) > 0 ? $movies[0] : false;
    }

    ////////////////////////////////////////////////////////////////////////////////////
    //
    //              Misc functions
    //
    static function get_short_title($movie, $view_type)
    {
        $string = $movie->name;
        $year = $movie->year;
        $genres_str = $movie->genres_str;
        $has_new_series = $movie->has_new_series;
        
        $t = $string;
        $tmpTitle = explode('/', $string);
        if(count($tmpTitle)){
            $string = $tmpTitle[0];
        }
        
        $tmpTitle = explode('|', $string);
        if(count($tmpTitle)){
            $string = $tmpTitle[0];
        }
        
        $tmpTitle = explode('\\', $string);
        if(count($tmpTitle)){
            $string = $tmpTitle[0];
        }
        
        $string = self::clear($string);
        
    
        $video = self::video($t);
        
        $year = self::clear($year);
        
        $genres_str = self::clear($genres_str);
        
        $_year = empty($year) || $year == '-1' ? '' :' (' . $year . ')';
        
        $new_mark = '';
        if ($has_new_series)
            $new_mark = '[Н]';

        if ($view_type == 0)
        {
            $title = 'Название:';
            if (mb_strlen($string, "UTF-8") <= 20)
            {
                $title .= '|' . $string;
            }
            else
            {
                // split long titles for rows
                hd_print("--->>> " . $string);
                $words = explode(' ', $string);
                $row = '';
                foreach($words as $word)
                {
                    hd_print("---->>>>word: '$word'");
                    hd_print("---->>>>len of row . word: '$row $word' " . (mb_strlen($row . $word, "UTF-8") + 1));
                    if (mb_strlen(trim($word), "UTF-8") == 0)
                        continue;
                    if ((mb_strlen($row . $word, "UTF-8") + 1) <= 20)
                    {
                        $row .= $word . ' ';
                    }
                    else
                    {
                        $title .= '|' . $row;
                        $row = $word . ' ';
                    }
                    hd_print("---->>>>title: '$title'");
                    hd_print("---->>>>row: '$row'");
                }
                hd_print("---->>>>row: '$row'");
                if (mb_strlen(trim($row), "UTF-8") > 0)
                    $title .= '|' . $row;
            }
            
            if ($has_new_series)
                $title .= '|(Есть новые серии)';
            if (!empty($year) && $year != '-1')
                $title .= '||Год:|' . $year;
            
            $title .= '||Качество:|' . $video;
            if (strlen(trim($genres_str)) > 0)
            {
                $title .= '||Жанр:';
                $genres_list = explode(',', $genres_str);
                foreach($genres_list as $genre)
                {
                    $title .= '|' . trim($genre);
                }
            }
                        
            $title .= '||Продолжительность:|' . HD::format_duration(intval($movie->length_min) * 1000);
        }
        else
        {
            $title = $new_mark . $string . '|' . $_year . $video. '|' . $genres_str;
        }
        
        return $title;
    }
    
    static function clear($str)
    {
        return str_replace(array("&quot;","&nbsp;","&#39;","8px' align=right>"), array("\""," ","'",""), $str);
    }
    
    static function video($string)
    {
        $video = '';
        $d = '';
        
        if( preg_match('/720p/i',$string) )
        {
            $d = 'HD720p';
        }
        else if( preg_match('/1080p/i',$string) )
        {
            $d = 'HD1080p';
        }
        else
            $d = "SD";
        
        if( preg_match('/HDRip/i',$string) )
        {
            $video = "HDRip";
        }
        else if( preg_match('/BDRip/i',$string) )
        {
            $video = "BDRip";
        }
        else if( preg_match('/DVDRip/i',$string) )
        {
            $video = "DVDRip";
        }
        
        if( !empty($d) )
        {
            return ' [' . (empty( $video ) ? $d:$d.', '.$video). ']';
        }
        return ' [' . $video . ']';
    }
    
}

?>
