<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

require_once 'ExUa_setup_screen.php';
///////////////////////////////////////////////////////////////////////////

class ExUaMainMenuScreen extends AbstractPreloadedRegularScreen implements UserInputHandler
{
    const ID = 'main_menu';
    
    private $skins;

    public function __construct($skins)
    {
        parent::__construct(self::ID);
        
        $this->skins = $skins;
        
        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    public function get_handler_id()
    { return self::ID; }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        $add_action = UserInputHandlerRegistry::create_action($this, 'settings');
        $add_action['caption'] = 'Настройки плагина';

        return  array
                (
                    GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
                    GUI_EVENT_KEY_C_YELLOW => $add_action,
                );
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('vod_series_list: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");
            
        switch ($user_input->control_id)
        {
        case 'settings':
            return ActionFactory::open_folder(ExUaSetupScreen::get_media_url_str(), "Настройки");
        }
        
        return null;
    }
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
        $items = array();
        
        $skin = $this->skins->get_current_skin($plugin_cookies);

        $items = array
        (
            array
            (
                PluginRegularFolderItem::caption => 'Видео',
                PluginRegularFolderItem::view_item_params => $skin->get_main_items_view_params_video($plugin_cookies),
                PluginRegularFolderItem::media_url => 'vod_category_list'
            ),
            array
            (
                PluginRegularFolderItem::caption => 'Аудио',
                PluginRegularFolderItem::view_item_params => $skin->get_main_items_view_params_audio($plugin_cookies),
                PluginRegularFolderItem::media_url => 'audio_category_list'
            ),
            array
            (
                PluginRegularFolderItem::caption => 'Поиск',
                PluginRegularFolderItem::view_item_params => $skin->get_main_items_view_params_search($plugin_cookies),
                PluginRegularFolderItem::media_url => 'search_history'
            ),
            array
            (
                PluginRegularFolderItem::caption => 'Избранное',
                PluginRegularFolderItem::view_item_params => $skin->get_main_items_view_params_favorites($plugin_cookies),
                PluginRegularFolderItem::media_url => 'vod_favorites'
            ),
        );

        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    protected function do_get_folder_views(&$plugin_cookies)
    {
        return $this->skins->get_current_skin($plugin_cookies)->GET_MAIN_MENU_FOLDER_VIEWS($plugin_cookies);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
