<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'skins/skins.php';

require_once 'ExUa_config.php';

require_once 'ExUa_main_menu_screen.php';
require_once 'ExUa_vod.php';
require_once 'ExUa_setup_screen.php';
require_once 'ExUa_search_history.php';
require_once 'ExUa_vod_category_list_screen.php';
require_once 'ExUa_vod_list_screen.php';
require_once 'ExUa_vod_series_list_screen.php';
require_once 'ExUa_vod_favorites_screen.php';
require_once 'ExUa_vod_movie_screen.php';

require_once 'ExUa_audio_category_list_screen.php';

///////////////////////////////////////////////////////////////////////////

class ExUaPlugin extends DefaultDunePlugin
{
    private $skins;
    
    public function __construct()
    {
        if (file_exists(ExUaConfig::SKINS_PATH) && is_dir(ExUaConfig::SKINS_PATH))
            $this->skins = new ExUaSkins(ExUaConfig::PLUGIN_PATH, ExUaConfig::SKINS_PATH);
        else
            $this->skins = new ExUaSkins(ExUaConfig::PLUGIN_PATH_FLASH, ExUaConfig::SKINS_PATH_FLASH);

        $this->vod = new ExUaVod($this->skins);

        $this->add_screen(new ExUaMainMenuScreen($this->skins));
        $this->add_screen(new ExUaSetupScreen($this->skins));
        $this->add_screen(new ExUaVodCategoryListScreen($this->skins));
        $this->add_screen(new ExUaVodListScreen($this->vod, $this->skins));
        $this->add_screen(new ExUaAudioCategoryListScreen($this->skins));
        $this->add_screen(new ExUa_search_history($this->vod, $this->skins));
        $this->add_screen(new ExUaVodFavoritesScreen($this->vod, $this->skins));

        $this->add_screen(new ExUaVodMovieScreen($this->vod));
        $this->add_screen(new ExUaVodSeriesListScreen($this->vod));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
